unit frmCreateTeam;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, Configuration, TeamManager;

type

  { Tfrm_CreateTeam }

  Tfrm_CreateTeam = class(TForm)
    btn_Add: TButton;
    btn_Cancel: TButton;
    btn_AddMember: TButton;
    btn_RemoveMember: TButton;
    cob_Nation: TComboBox;
    ed_Name: TEdit;
    ed_TeamName: TEdit;
    gb_Members: TGroupBox;
    gb_TeamName: TGroupBox;
    gb_Team: TGroupBox;
    gb_Member: TGroupBox;
    lbl_Nation: TLabel;
    lbl_Name: TLabel;
    lb_Members: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btn_AddClick(Sender: TObject);
    procedure btn_AddMemberClick(Sender: TObject);
    procedure btn_CancelClick(Sender: TObject);
    procedure btn_RemoveMemberClick(Sender: TObject);
    procedure ed_NameChange(Sender: TObject);
    procedure lb_MembersClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  frm_CreateTeam: Tfrm_CreateTeam;

implementation

uses
  frmMain;

{ Tfrm_CreateTeam }

procedure Tfrm_CreateTeam.btn_CancelClick(Sender: TObject);
begin
  Close;
end;

procedure Tfrm_CreateTeam.btn_RemoveMemberClick(Sender: TObject);
begin
  lb_Members.Items.Delete(lb_Members.ItemIndex);
  gb_Member.Hide;
end;

procedure Tfrm_CreateTeam.ed_NameChange(Sender: TObject);
begin
  gb_Member.Caption := ed_Name.Text;
  lb_Members.Items[lb_Members.ItemIndex] := ed_name.Text;
end;

procedure Tfrm_CreateTeam.lb_MembersClick(Sender: TObject);
var
  _TempIndex : Integer;
begin
  _TempIndex := lb_Members.ItemIndex;
  if _TempIndex > -1 then
  begin
    gb_Member.Caption := lb_Members.Items[_TempIndex];
    ed_Name.Text := lb_Members.Items[_TempIndex];
    gb_Member.Show;
  end else
    gb_Member.Hide;
end;

procedure Tfrm_CreateTeam.FormShow(Sender: TObject);
begin
  //warunki poczatkowe
  lb_Members.Clear;
  ed_TeamName.Text := 'Druzyna_1';
  cob_Nation.ItemIndex := 0;
end;

procedure Tfrm_CreateTeam.btn_AddClick(Sender: TObject);
var
  _Team : TTeam;
  i : Integer;
begin
  if lb_Members.Items.Count = 0 then
  begin
    ShowMessage('Druzyna musi zawierac conajmniej jednego zawodnika!');
    Exit;
  end;
  
  _Team := TTeam.Create;
  _Team.Name := ed_TeamName.Text;
  _Team.Nation := cob_Nation.ItemIndex;
  for i := 0 to lb_Members.Items.Count - 1 do
    _Team.AddMember(lb_Members.Items[i]);
  TeamMngr.AddTeam(_Team);
  frm_Main.AddTeam(_Team);
  Close;
end;

procedure Tfrm_CreateTeam.btn_AddMemberClick(Sender: TObject);
begin
  lb_Members.Items.Add('Zawodnik_' + IntToStr(lb_Members.Items.Count));
end;

procedure Tfrm_CreateTeam.FormCreate(Sender: TObject);
begin
  cob_Nation.Items.LoadFromFile(MainConfig.MainDir + '/gfx/rasy');
end;

initialization
  {$I frmcreateteam.lrs}

end.

