unit Timer;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sdl;
  
type

  { TTimer }

  PTimer = ^TTimer;
  TTimer = class
  private
    FStartTicks,
    FPausedTicks : Cardinal;
    FFps : Cardinal;
    FPaused,
    FStarted : Boolean;
    function GetTicks : Cardinal;
    function GetRealFps : Cardinal;
  public
    constructor Create;
    procedure Start;
    procedure Stop;
    procedure Pasue;
    procedure UnPause;
    //czekaj do konca klatki
    procedure Wait;
    
    property IsStarted : Boolean read FStarted;
    property IsPaused : Boolean read FPaused;
    property Fps : Cardinal read GetRealFps write FFps;
  end;

implementation

{ TTimer }

function TTimer.GetTicks: Cardinal;
begin
  Result := 0;
  
  if FStarted then
    if FPaused then
      Result := FPausedTicks
    else
      Result := SDL_GetTicks - FStartTicks;
end;

constructor TTimer.Create;
begin
  FStartTicks := 0;
  FPausedTicks := 0;
  FPaused := False;
  FStarted := False;
end;

procedure TTimer.Start;
begin
  FStarted := True;
  FPaused := False;
  FStartTicks := SDL_GetTicks;
end;

procedure TTimer.Stop;
begin
  FStarted := False;
  FPaused := False;
end;

procedure TTimer.Pasue;
begin
  if FStarted and not FPaused then
  begin
    FPaused := True;
    FPausedTicks := SDL_GetTicks - FStartTicks;
  end;
end;

procedure TTimer.UnPause;
begin
  if FPaused then
  begin
    FPaused := False;
    FStartTicks := SDL_GetTicks - FPausedTicks;
    FPausedTicks := 0;
  end;
end;

procedure TTimer.Wait;
begin
  while GetTicks < 1000 div FFps do SDL_Delay(5);
end;

function TTimer.GetRealFps: Cardinal;
begin
  Result := 1000 div GetTicks;
end;

end.

